MSInterface
Date: 2019-10-22

org.jmol.adapter.smarter

## Interface MSInterface

- All Known Implementing Classes:
    MSCifParser, MSRdr

      public interface MSInterface

  Modulated Structure Reader Interface

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `addLatticeVector(javajs.util.Lst<float[]> lattvecs, java.lang.String substring)`
    `void` | `addModulation(java.util.Map<java.lang.String,double[]> map, java.lang.String id, double[] pt, int iModel)`
    `void` | `addSubsystem(java.lang.String code, javajs.util.Matrix w)`
    `void` | `finalizeModulation()`
    `SymmetryInterface` | `getAtomSymmetry(Atom a, SymmetryInterface symmetry)`
    `double[]` | `getMod(java.lang.String key)`
    `char` | `getModType(java.lang.String key)`
    `java.util.Map<java.lang.String,double[]>` | `getModulationMap()`
    `double[]` | `getQCoefs(java.lang.String key)`
    `SymmetryInterface` | `getSymmetryFromCode(java.lang.String spaceGroupOperationCode)`
    `int` | `initialize(AtomSetCollectionReader r, int modDim)`
    `void` | `setMinMax0(javajs.util.P3 minXYZ0, javajs.util.P3 maxXYZ0)`
    `void` | `setModulation(boolean isPost, SymmetryInterface symmetry)`

- - ### Method Detail

    - #### addModulation

          void addModulation(java.util.Map<java.lang.String,double[]> map,
                             java.lang.String id,
                             double[] pt,
                             int iModel)

    - #### addSubsystem

          void addSubsystem(java.lang.String code,
                            javajs.util.Matrix w)

    - #### finalizeModulation

          void finalizeModulation()

    - #### getMod

          double[] getMod(java.lang.String key)

    - #### initialize

          int initialize(AtomSetCollectionReader r,
                         int modDim)
                  throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### setModulation

          void setModulation(boolean isPost,
                             SymmetryInterface symmetry)
                      throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getAtomSymmetry

          SymmetryInterface getAtomSymmetry(Atom a,
                                            SymmetryInterface symmetry)

    - #### setMinMax0

          void setMinMax0(javajs.util.P3 minXYZ0,
                          javajs.util.P3 maxXYZ0)

    - #### getSymmetryFromCode

          SymmetryInterface getSymmetryFromCode(java.lang.String spaceGroupOperationCode)

    - #### addLatticeVector

          boolean addLatticeVector(javajs.util.Lst<float[]> lattvecs,
                                   java.lang.String substring)
                            throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getModulationMap

          java.util.Map<java.lang.String,double[]> getModulationMap()

    - #### getModType

          char getModType(java.lang.String key)

    - #### getQCoefs

          double[] getQCoefs(java.lang.String key)